#!/bin/ettclsh

proc Url_Decode {url} {
    regsub -all {\+} $url { } url
    regsub -all {%([0-9a-hA-H][0-9a-hA-H])} $url \
            {[format %c 0x\1]} url
    return [subst $url]
}

# This is known to be a POST cgi...
set query [gets stdin]

#provide defaults
set opt(enable) 1
set opt(target) ""

foreach {name value} [split $query &=] {
    set opt($name) [Url_Decode $value]
}

set F [open /dev/etcustom0 w]
fconfigure $F -buffering line

# Enable or disable
if $opt(enable) {puts $F e} else {puts $F d}

# Write the target
if [llength $opt(target)] {puts $F $opt(target)}

close $F

# And a silly message...
puts {<html><head>
	<title>Ok</title>
	<meta http-equiv="Refresh" content="5; URL=/cgi-bin/stepper">
	</head>
	<body>Request successfully sent</body></html>
}

exit
