#!/bin/ettclsh

proc Url_Decode {url} {
    regsub -all {\+} $url { } url
    regsub -all {%([0-9a-hA-H][0-9a-hA-H])} $url \
            {[format %c 0x\1]} url
    return [subst $url]
}

# This is known to be a POST cgi...
set query [gets stdin]

#provide defaults
foreach n "0 1 2 3 4" {set opt(led$n) 0}

foreach {name value} [split $query &=] {
    set opt($name) [Url_Decode $value]
}

foreach n "0 1 2 3 4" {
	set real [expr $n+5]
	set F [open /dev/et3i$real w]; puts $F $opt(led$n); close $F
}

# And a silly message...
puts {<html><head>
	<title>Ok</title>
	</head>
	<body><a href="leds">Update successful</a></body></html>
}

exit
