#!/bin/ettclsh

# output file for font data and input font
set ofile /dev/etcustom2
set spfile /dev/etcustom3
set fontdir /lib/font


proc Url_Decode {url} {
    regsub -all {\+} $url { } url
    regsub -all {%([0-9a-hA-H][0-9a-hA-H])} $url \
            {[format %c 0x\1]} url
    return [subst $url]
}

# This is known to be a POST cgi...
set query [gets stdin]

#provide defaults
set opt(text) ""

foreach {name value} [split $query &=] {
    set opt($name) [Url_Decode $value]
}


proc strtobin string {
    global ofile fontdir

    set splitted [split $string ""]
    set F [open $ofile w]
    foreach char $splitted {
	scan $char %c ascii
	if [catch {set I [open $fontdir/$ascii]}] continue
	fcopy $I $F
	close $I
    }
    close $F
}

strtobin $opt(text)

set F [open $spfile w]
puts $F $opt(speed)
close $F

# And a silly message...
puts {<html><head>
	<title>Ok</title>
	</head>
	<body><a href="string">Update successful</a></body></html>
}

exit
